
# mysql-querybuilder-nodejs

mysql query bulder for nodejs

## Usage/Examples
first install import package

install package
``` bash
    npm i mysql-querybuilder-nodejs
```

import package
```javascript
const query_builder = require('mysql-querybuilder-nodejs');
const db = query_builder(dbname, username, password,host, port);
```

### Select Data
#### Single Data (row)
```javascript
const query_builder = require('mysql-querybuilder-nodejs');
const db = query_builder(dbname, username, password,host, port);
db.select('column').from('tabel').row(callback, 'table if you not using from function');

function callback(error, result){
    //do something
}
```

#### Single Data (row) async
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel').row_async('table if you not using from function');

    // You can get data without await
    const result = await db.select('column').from('tabel').row_async('table if you not using from function').then().catch();
```

#### Multiple Data
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    db.select('column').from('tabel').results(callback, 'table if you not using from function');

    function callback(error, result){
        //do something
    }
```

#### Multiple Data (async)
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel').results_async('table if you not using from function');

    // You can get data without await
    const result = await db.select('column').from('tabel').results_async('table if you not using from function').then().catch();
```

#### Filter Data
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel')
        .where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .or_where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .results_async('table if you not using from function');
```

#### Join Table
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel')
        .where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .or_where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .join('table', 'condition', 'type')
        .results_async('table if you not using from function');

```

#### Grouping
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel')
        .where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .or_where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .group_by('column')
        .results_async('table if you not using from function');

```
#### Order
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    const result = await db.select('column').from('tabel')
        .where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .or_where('column' 'value', 'operator', 'string_value | true or false, default true, use true if the value is string' )
        .group_by('column')
        .order_by('column', 'order type')
        .results_async('table if you not using from function');

```

### Insert Data
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    db.insert('table', 'inputs (object) , callback);

    // you can use insert_async
    db.insert_async('table', 'inputs (object) , callback);
```

### Update Data
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    db.where('id', data.id)
        .update('table', 'inputs in object', callback);

     // you can use update_async
    db.delete_async('table', 'inputs (object)');
```
### Delete Data
```javascript
    const query_builder = require('mysql-querybuilder-nodejs');
    const db = query_builder(dbname, username, password,host, port);
    db.where('id', data.id)
    .delete('table', callback);
    
    // you can use delete_async
    db.where('id', data.id)
    .delete('table');
```
